<?php
/**
 * URL-Rewrite Addon
 * @author wolfgang[at]busch-dettum[dot]de Wolfgang Busch
 * @package redaxo5
 * @version September 2017
 */
#
$string='
<div>Ein URL hat in Redaxo die Normalform
<code>index.php?article_id=ID&amp;clang=CID</code>
mit Verweis auf die Artikel-Id ID mit der Sprach-Id CID.<br/>
In der Regel soll stattdessen jeder Artikel einen &quot;Wunsch-URL&quot;
erhalten, aus dem Hinweise auf Themen-Kategorien und den Artikelinhalt
entnommen werden knnen. In diesem AddOns werden dazu die Id, der
Sprach-Code und der Name des Artikels herangezogen.<br/>
Als Besonderheit: Auch ohne De-Installation dieses AddOns knnen URLs
in Normalform benutzt werden.</div>
<br/>
<div style="font-weight:bold;">RewriteRule in der .htaccess-Datei</div>
<div style="padding-left:20px;">Mit der folgenden RewriteRule werden
alle nicht auf Dateien weisenden URLs auf die Datei <tt>/index.php</tt>
umgeleitet:<br/>
<code> &nbsp; RewriteRule ^(.*)$ index.php?%{QUERY_STRING} [L]</code><br/>
Da Redaxo keinen entsprechenden Artikel hat, landet die Umleitung auf
dem Site-Startartikel.</div>
<br/>
<div style="font-weight:bold;">Setzen des Wunsch-URLs</div>
<div style="padding-left:20px;">Dazu ist eine Erweiterung des
<code>Extension Point URL_REWRITE</code> erforderlich. Die am
Extension Point aufgerufene Funktion gibt den Wunsch-URL zurck.
Eingabeparameter der Funktion ist ein Objekt, das Id und
Sprach-Id eines Artikels sowie den URL-Parameterstring enthlt.
Der zurckgegebene URL liefert den Wert der Variablen
<code>$_SERVER["REQUEST_URI"]</code> und den Rckgabewert der
Funktion <code>rex_getUrl($article_id)</code>.<br/>
Im Backend wird die Funktion nur im Content-Kontext eines
Artikels (edit, metainfo, functions) aufgerufen.
Eingabeparameter sind daher dessen Id und Sprach-Id.<br/>
Im Frontend entsprechen die Eingabeparameter der Funktion gem
obiger RewriteRule den Parametern des Site-Startartikels. Daher
muss der anzuzeigende Artikel samt Sprach-Id aus dem Wunsch-URL
ermittelt werden. Auerdem muss der Frontend-Output so
manipuliert werden, dass nicht (gem eingegebener Artikel-Id)
der Site-Startartikel angezeigt wird.</div>
<br/>
<div style="font-weight:bold;">Manipulation des Frontend-Outputs</div>
<div style="padding-left:20px;">Sie erfolgt durch eine Erweiterung
des <code>Extension Point FE_OUTPUT</code>. Die am Extension Point
aufgerufene Funktion hat keine Eingabeparameter. Ein Aufruf erfolgt
nur im Frontend-Fall. Aus dem URL der anzuzeigenden Seite wird der
zugehrige Artikel samt Sprach-Id ermittelt und zur Anzeige gebracht.
Die Ergebnisse der Funktionen <tt>rex_article::getCurrentId()</tt>
und <tt>rex_clang::getCurrentId()</tt> werden entsprechend
korrigiert.</div>
<div style="font-weight:bold;">Ausblick auf komplexere Wunsch-URLs</div>
<div style="padding-left:20px;">Beim URL-Rewrite sind die beiden
folgenden Aufgaben zu lsen:<br/>
 &nbsp; 1) Konstruktion des Wunsch-URL aus Artikel-Id und Sprach-Id
(Backend)<br/>
 &nbsp; 2) Ermitteln des Artikels samt Sprach-Id zu einem URL (Frontend
und Output)<br/>
Wenn der URL als zustzlicher Artikel-Parameter (Metainfo) mitgefhrt
wird, ist Aufgabe 2 relativ einfach und effizient ber ein SQL-Select
auf die Tabelle rex_article lsbar. Zur Lsung von Aufgabe 1 bietet
sich der path-Parameter des Artikels und ein Rckgriff auf den
Artikel-Cache an.</div>
<br/>
';
echo utf8_encode($string);
?>
